#include "lista.h"

void cria(Lista *L) {
     L->inicio=NULL;
     L->fim=NULL;
}

void finaliza(Lista *L) {
     no *p;
     p=L->inicio;
     while (p!=NULL) {
           L->inicio=L->inicio->prox;
           free(p);
           p=L->inicio;
     }
     L->fim=NULL;
}

void inserir(Lista *L, elem x) {
     no *p;
     
     p=(no*) malloc(sizeof(no));
     p->info=x;
     p->prox=NULL;
     if (L->inicio==NULL)
        L->inicio=p;
     else L->fim->prox=p;
     L->fim=p;
            
}

void imprimir(Lista *L) {
     no *p;
     
     p=L->inicio;
     while (p!=NULL) {
           printf("%c ",p->info);
           p=p->prox;
     }
     
}

void troca(Lista *L, no *ant1, no *i, no *ant2, no *j) {
     no *aux;
     
     if (i->prox==j) {
        i->prox=j->prox;
        j->prox=i;
        if (ant1!=NULL)
           ant1->prox=j;
     }
     else {
          aux=i->prox;
          i->prox=j->prox;
          j->prox=aux;
          if (ant1!=NULL)
             ant1->prox=j;
          ant2->prox=i;
     }
     if (L->inicio==i)
        L->inicio=j;
     if (L->fim==j)
        L->fim=i;
}

void ordena(Lista *L) {
     no *i, *ant1, *j, *ant2, *aux;
     
     ant1=NULL;
     i=L->inicio;
     while (i!=NULL) {
           
           ant2=i;
           j=i->prox;
           while (j!=NULL) {
                 
                 if (j->info<i->info) {
                    troca(L,ant1,i,ant2,j);
                    if (j->prox==i)
                       ant2=j;
                    aux=i;
                    i=j;
                    j=aux;
                 }
                 
                 ant2=j;
                 j=j->prox;
           }                      
           
           ant1=i;
           i=i->prox;
     }     
}

